#ifndef _SINGLETON_H_
#define _SINGLETON_H_

#include "damldb/Portability.hh"

//
// PROJECT: Feasibility
// FILENAME: Singleton.h
// ORIGINAL AUTHOR: Paul Whitehead
// ORIGINAL CREATION DATE: 11th Jan 1999
// DESIGN DOCUMENT NO.:
//
// DESCRIPTION:
//
// $Date: 2002/04/11 18:21:26 $
//
// Acknowledgement: http://codeguru.com/cpp_mfc/leakfree_singleton.shtml

#ifdef CCXX_NAMESPACES
namespace damldb {
#endif

  template<class T>
  class CSingleton
  {
  private:
    class InstPtr
    {
    public:
      InstPtr() : m_ptr(0) {}
      ~InstPtr() { delete m_ptr; }
      T* Get() { return m_ptr; }
      void Set(T* p)
      {
	if(p!= 0)
	  {
	    delete m_ptr;
	    m_ptr = p;
	  }
      }
    private:
      T* m_ptr;
    };

    static InstPtr sm_ptr;
    CSingleton();
    CSingleton(const CSingleton&);
    CSingleton& operator=(const CSingleton&);

  public:
    static T* Instance()
    {
      if(sm_ptr.Get() == 0)
        {
	  sm_ptr.Set(new T());
        }
      return sm_ptr.Get();
    }
  };

#ifdef CCXX_NAMESPACES
} // namespace damldb
#endif

#endif // #ifndef _SINGLETON_H_

// Emacs
// Local Variables:
// mode: c++
// c-basic-offset: 2
// End:
