
#ifndef _DAMLDB_MYSQL_H
#define _DAMLDB_MYSQL_H

#include "damldb/Portability.hh"
#include "damldb/cdecls.h"

#if defined(HAVE_LIBMYSQLCLIENT)
#  include <mysql.h>
#else

BEGIN_C_DECLS

#undef MYSQL_PORT
#define MYSQL_PORT 3306

typedef char MYSQL;
typedef char MYSQL_RES;
typedef char **MYSQL_ROW;

MYSQL *		mysql_init(MYSQL *mysql);
char *		mysql_error(MYSQL *mysql);
void		mysql_close(MYSQL *sock);
void		mysql_free_result(MYSQL_RES *result);

MYSQL *	mysql_real_connect(MYSQL *mysql, const char *host,
			   const char *user,
			   const char *passwd,
			   const char *db,
			   unsigned int port,
			   const char *unix_socket,
			   unsigned int clientflag);

int		mysql_select_db(MYSQL *mysql, const char *db);
int		mysql_query(MYSQL *mysql, const char *q);
MYSQL_RES *	mysql_store_result(MYSQL *mysql);
MYSQL_ROW	mysql_fetch_row(MYSQL_RES *result);

END_C_DECLS

#endif /* !HAVE_LIBMYSQLCLIENT */

#endif /* !_DAMLDB_MYSQL_H */

/** Emacs:
 *  Local Variables:
 *  mode: c
 *  c-basic-offset: 2
 *  End:
 */
