// $Id: ResPOIterator.java,v 1.1 2002/04/05 04:21:52 neves Exp $


package org.daml.damldb.jena;


/**
 * return subjects that match the predicate and object
 */
class ResPOIterator
    extends ResIterator
{
    long predicate;
    long object;
    long statement;
    boolean literalObject;
    boolean nextStatementSet = false;
    long nextStatement;

    ResPOIterator(long predicate,
		  long object,
		  boolean literalObject)
    {
	this.predicate = predicate;
	this.object = object;
	this.literalObject = literalObject;
    }

    /**
     * internal method
     */
    long getNextStatement()
    {
	if (eof)
	    return 0;
	if (nextStatementSet)
	    return nextStatement;
	
	if (first)
	    {
		first = false;
		statement = org.daml.damldb.DAMLDB.firstObject(object);
	    }
	else
	    statement = org.daml.damldb.DAMLDB.nextObject(statement);

	for (;
	     statement != org.daml.damldb.DAMLDB.NULL_STATEMENT_ID;
	     statement = org.daml.damldb.DAMLDB.nextObject(statement))
	    {
		if (org.daml.damldb.DAMLDB.predicate(statement) == predicate)
		    {
			nextStatement = statement;
			nextStatementSet = true;
			return statement;
		    }
	    }
	eof = true;
	return 0;
    }
    
    static void unimplemented(String name)
    {
        System.err.println("ResPOIterator." + name + " unimplemented");
    }

    public com.hp.hpl.mesa.rdf.jena.model.Resource next()
        throws java.util.NoSuchElementException, 
               com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
	statement = getNextStatement();
	nextStatementSet = false;
	if (eof)
	    return null;
	
	return org.daml.damldb.jena.Model.getResource(org.daml.damldb.DAMLDB.subject(statement));
    }

    public void remove()
        throws java.util.NoSuchElementException, 
               com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
        unimplemented("remove");
    }

    public boolean hasNext()
        throws com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
        getNextStatement();
	return (! eof);
    }

    public void close()
        throws com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
    }
}
