// $Id: StmtIterator.java,v 1.1 2002/04/05 04:21:52 neves Exp $


package org.daml.damldb.jena;


abstract class StmtIterator
    extends Iterator
    implements com.hp.hpl.mesa.rdf.jena.model.StmtIterator
{
    /**
     * current statement being looked at
     */
    long statement;
    /**
     * next statement to return
     */
    long nextStatement;
    boolean nextStatementSet = false;
    /**
     * maximum number of statements
     */
    long nstatements = org.daml.damldb.DAMLDB.size();

    /**
     * specializer must specify
     */
    abstract boolean test(long statement)
	throws Exception;
    
    /**
     * internal method
     */
    long getNextStatement()
	throws com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
	if (eof)
	    return 0;
	if (nextStatementSet)
	    return nextStatement;
	
	if (first)
	    {
		first = false;
		statement = 0;
	    }
	else
	    statement = statement + 1;

	for (;
	     statement < nstatements;
	     statement++)
	    {
		try {
		    if (test(statement))
			{
			    nextStatement = statement;
			    nextStatementSet = true;
			    return statement;
			}
		} catch (Exception e) {
		    e.printStackTrace(); // XXX
		    throw new com.hp.hpl.mesa.rdf.jena.model.RDFException(e);
		}
	    }
	eof = true;
	return 0;
    }

    static void unimplemented(String name)
    {
        System.err.println("StmtIterator." + name + " unimplemented");
    }

    public com.hp.hpl.mesa.rdf.jena.model.Statement next()
        throws java.util.NoSuchElementException, 
               com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
	statement = getNextStatement();
	nextStatementSet = false;
	if (eof)
	    return null;
	
	return new Statement(statement);
    }

    public void remove()
        throws java.util.NoSuchElementException, 
               com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
        unimplemented("remove");
    }

    public boolean hasNext()
        throws com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
	getNextStatement();
	return (! eof);
    }

    public void close()
        throws com.hp.hpl.mesa.rdf.jena.model.RDFException
    {
    }
}
