
#ifndef lint
static const char revid[] = 
	"@(#)$Id: DBFactoryImpl.cpp,v 1.2 2002/04/09 21:59:51 neves Exp $";
#endif

#include "damldb/DBFactoryImpl.hh"
#include "damldb/DamlDBImpl.hh"
#include "damldb/Portability.hh"
#include "damldb/Types.hh"

#ifdef CCXX_NAMESPACES
namespace damldb {
#endif

  const string kSTATEMENT_FILE	= string("statements.mem");
  const string kRESOURCE_FILE	= string("resources.mem");

  IDamlDB* DBFactoryImpl::newDatabase(const string& directory,
					    const int open_mode)
  {
    IDamlDB* retVal = NULL;
    stmt_mapped_allocator stmt_alloc(directory.c_str(),
				     kSTATEMENT_FILE.c_str(),
				     open_mode);

    res_mapped_allocator res_alloc (directory.c_str(),
				     kRESOURCE_FILE.c_str(),
				     open_mode);

    retVal = new DamlDBImpl(directory, open_mode, stmt_alloc, res_alloc);

    return retVal;
  }

#ifdef CCXX_NAMESPACES
} // namespace damldb
#endif

// Emacs
// Local Variables:
// mode: c++
// c-basic-offset: 2
// End:
