
#ifndef lint
static const char revid[] =
	"@(#)$Id: OS.cpp,v 1.2 2002/04/09 21:59:51 neves Exp $";
#endif

#include "damldb/OS.hh"

#if defined (_WIN32)
#  include <windows.h>
#  include <io.h>		// for _access
#endif

#if defined(__CYGWIN__)
#  include <windows.h>
#  include <sys/cygwin.h>
#endif

#include <cstdlib>
#include <iostream>

#ifdef CCXX_NAMESPACES
namespace damldb {
USING(std);
#endif

  //////////////////////////////////////////////////////////////////////

  int
  OS::access(const string& path, int mode)
  {
#if !defined(__CYGWIN__) && defined (_WIN32)
    return _access(path.c_str(), mode);
#else
    return ::access(path.c_str(), mode);
#endif
  }

  //////////////////////////////////////////////////////////////////////

  char
  OS::filesep()
  {
#if defined(_MCS_VER)
    return '\\';
#else
    return '/';
#endif
  }

  //////////////////////////////////////////////////////////////////////

  char* 
  OS::getenv(const char* name)
  {
    char* retVal = ::getenv(name);
    return retVal;
  }

  //////////////////////////////////////////////////////////////////////

  Time_Value
  OS::gettimeofday (void)
  {
    timeval tv;

#if defined(HAVE_GETTIMEOFDAY)
    ::gettimeofday (&tv, 0);
#endif

    return Time_Value(tv);
  }

  //////////////////////////////////////////////////////////////////////

  void
  OS::maybe_convert_path(const string& pathname, string& convertedName)
  {
    OS::maybe_convert_path(&pathname, convertedName);
  }

  //////////////////////////////////////////////////////////////////////

  void
  OS::maybe_convert_path(const string* pathname, string& convertedName)
  {
#if defined(__CYGWIN__)
    char buf[MAX_PATH];
    (void) cygwin_conv_to_win32_path(pathname->data(), buf);
    convertedName = buf;
#else
    convertedName = *pathname;
#endif
  }

#ifdef CCXX_NAMESPACES
} // namespace damldb
#endif

// Emacs
// Local Variables:
// mode: c++
// c-basic-offset: 2
// End:

