
#ifndef lint
static const char revid[] =
	"@(#)$Id: Time_Value.cpp,v 1.2 2002/04/09 21:59:51 neves Exp $";
#endif // not lint

/**
   Time_Value encapsulates the timeval structure for portability.

   CREDIT: Doug Schmidt <schmidt@cs.wustl.edu> ACE Library

   NOTE: This interface was derived from the ACE_Time_Value Class.
   It has been locally modified to extract it from ACE.
*/

#include "damldb/Time_Value.hh"

#include <iostream>

#ifdef DAMLDB_OUTLINE
#define inline
#include "Time_Value.icc"
#undef inline
#endif

#ifdef CCXX_NAMESPACES
namespace damldb {
USING(std);
#endif

  const Time_Value Time_Value::zero;

  void
  Time_Value::dump (void) const
  {
    cout << "tv_sec_ = " << this->tv_.tv_sec << endl;
    cout << "tv_usec_ = " << this->tv_.tv_usec << endl;
  }

  void
  Time_Value::normalize (void)
  {
    // New code from Hans Rohnert...

    if (this->tv_.tv_usec >= DAMLDB_ONE_SECOND_IN_USECS)
      {
	do
	  {
	    this->tv_.tv_sec++;
	    this->tv_.tv_usec -= DAMLDB_ONE_SECOND_IN_USECS;
	  }
	while (this->tv_.tv_usec >= DAMLDB_ONE_SECOND_IN_USECS);
      }
    else if (this->tv_.tv_usec <= -DAMLDB_ONE_SECOND_IN_USECS)
      {
	do
	  {
	    this->tv_.tv_sec--;
	    this->tv_.tv_usec += DAMLDB_ONE_SECOND_IN_USECS;
	  }
	while (this->tv_.tv_usec <= -DAMLDB_ONE_SECOND_IN_USECS);
      }

    if (this->tv_.tv_sec >= 1 && this->tv_.tv_usec < 0)
      {
	this->tv_.tv_sec--;
	this->tv_.tv_usec += DAMLDB_ONE_SECOND_IN_USECS;
      }
    else if (this->tv_.tv_sec < 0 && this->tv_.tv_usec > 0)
      {
	this->tv_.tv_sec++;
	this->tv_.tv_usec -= DAMLDB_ONE_SECOND_IN_USECS;
      }
  }

#ifdef CCXX_NAMESPACES
} // namespace damldb
#endif

// Emacs
// Local Variables:
// mode: c++
// c-basic-offset: 2
// End:
